<%-- 
    Document   : ukazka
    Created on : 5.3.2008, 9:45:25
    Author     : Radek Muzika
--%>
<%@ page contentType="text/html" pageEncoding="UTF-8"%>
<%@ page import="org.springframework.context.ApplicationContext, org.springframework.web.context.support.WebApplicationContextUtils" %>
<%@ page import="cz.zcu.kiv.db.dao.UdalostDao, cz.zcu.kiv.db.model.udalosti.Udalost" %>
<%@ page import="java.util.*" %>

<%@ taglib prefix="c" 
           uri="http://java.sun.com/jsp/jstl/core" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<% /** Ziskani aplikacniho kontextu ze servlet kontextu. Aplikacni kontext nam umozni
        pristupovat k beans definovanym v IOC kontejneru. Aby bylo mozne ziskat kontext
        ze servlet kontextu, musí být ve web.xml definován listener ContextLoaderListener.

        Jinou moznosti jak ziskat kontext je primo nactenim konfiguracniho souboru
        pomoci ClassPathXmlApplicationContext nebo FileSystemXmlApplicationContext.
        Viz dokumentace ke spring frameworku.*/
    ApplicationContext ctx = WebApplicationContextUtils.getWebApplicationContext(config.getServletContext());
    
    /** Z aplikacniho kontextu ziskame DAO tridu udalostDao. Identifikátor pouzity
        k ziskani beany je bud totozny s nazvem tridy beany, nebo je implicitne
        uveden v konfiguraci (zde konkretne je uveden v anotaci @Repository("udalostDao")
        ve tride UdalostDaoImpl.*/
    UdalostDao uDao = (UdalostDao) ctx.getBean("udalostDao");
   
    /** DAO trida nam jiz poskytuje mnozstvi metod, ktere muzeme volat.*/
    List<Udalost> seznamUdalosti = uDao.getUdalosti();
   
    /** Ulozeni kolekce do kontextu stranky, aby mohla byt pozdeji pouzita pomoci jstl.*/
    pageContext.setAttribute("seznamUdalosti", seznamUdalosti);
%>

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>JSP Page</title>
    </head>
    <body>
        <table>
            <!--a href='vytvorUdalost.jsp'>nova udalost</a-->
            <tr><th></th><th></th><th>kod</th><th>nazev</th><th>popis</th><th>odpovedna osoba</th>

            <c:forEach items="${seznamUdalosti}" var="udalost">
                <tr>
                    <td><a href='upravUdalost.jsp?udalostId=<c:out value="${udalost.id}" />'>[ E ]</a></td>
                    <td><a href='smazUdalost.jsp?udalostId=<c:out value="${udalost.id}" />'>[ X ]</a></td>
                    <td><c:out value="${udalost.id}" /> </td>
                    <td><c:out value="${udalost.nazevCz}" /></td>
                    <td><c:out value="${udalost.popisCz}" /></td>
                    <!--    Pokud chceme vypsat jmeno odpovedne osoby, nemusime osobu nacitat
                            z databaze, staci zavolat getter a backend aplikace se postara
                            o nacteni osoby z databaze. -->
                    <td><a href="zobrazOsobu.jsp?osobaId=<c:out value="${udalost.odpovednaOsoba.id}" />">  <c:out value="${udalost.odpovednaOsoba.jmeno}" /> <c:out value="${udalost.odpovednaOsoba.prijmeni}" /></a></td>
                </tr>
            </c:forEach>
        </table>
    </body>
</html>
