<%-- 
    Document   : uloz.jsp
    Created on : 5.3.2008, 10:55:34
    Author     : Radek Muzika
--%>

<%@ page contentType="text/html" pageEncoding="UTF-8"%>
<%@ page import="org.springframework.context.ApplicationContext, org.springframework.web.context.support.WebApplicationContextUtils" %>
<%@ page import="cz.zcu.kiv.db.dao.*, cz.zcu.kiv.db.model.udalosti.Udalost, cz.zcu.kiv.db.model.osoby.Osoba" %>
<%@ page import="java.util.*, java.text.*" %>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">
<% 
    /** Ziskani aplikacniho kontextu ze servlet kontextu. Aplikacni kontext nam umozni
        pristupovat k beans definovanym v IOC kontejneru. Aby bylo mozne ziskat kontext
        ze servlet kontextu, musí být ve web.xml definován listener ContextLoaderListener.

        Jinou moznosti jak ziskat kontext je primo nactenim konfiguracniho souboru
        pomoci ClassPathXmlApplicationContext nebo FileSystemXmlApplicationContext.
        Viz dokumentace ke spring frameworku.*/
    ApplicationContext ctx = WebApplicationContextUtils.getWebApplicationContext(config.getServletContext());
    
    /** Ziskani hodnot formulare a jejich ulozeni do objektu.*/
    Udalost udalost = new Udalost();
    udalost.setId(Integer.parseInt((String)request.getParameter("id")));
    udalost.setNazevCz((String)request.getParameter("nazevCz"));
    udalost.setPopisCz((String)request.getParameter("popisCz"));
    DateFormat dateFormat = new SimpleDateFormat("dd.MM.yy");    
    udalost.setDatumZacatek(dateFormat.parse((String)request.getParameter("datumZacatek")));
    
    /** Ziskani DAO tridy a nacteni osoby, ktera ma byt udalosti prirazena
        jako odpovedna osoba. 
        Proc musi byt prirazena osoba? Protoze pri ukladani udalosti se z osoby ziska
        id a ulozi se jako cizi klic do databaze.
        Proc se musi nacitat cely objekt, misto toho aby se predalo jen id? Protoze
        nemuzeme apriori predpokladat ze backend bude vzdy potrebovat jen id. Pokud 
        by se zmenila logika v backendu, kdy by se zacala vyzadovat dalsi informace,
        pak by se musela upravit i view vrstva.*/
    OsobaDao oDao = (OsobaDao) ctx.getBean("osobaDao");    
    Osoba o = oDao.getOsoba(Integer.parseInt((String)request.getParameter("fkOsoba")));
    
    /** Prirazeni odpovedne osoby udalosti.*/
    udalost.setOdpovednaOsoba(o);
    
    /** Ziskani DAO tridy a ulozeni udalosti.*/
    UdalostDao uDao = (UdalostDao) ctx.getBean("udalostDao");
    uDao.ulozUdalost(udalost);
%>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>JSP Page</title>
    </head>
    <body>
        <h2>Ulozeno</h2>
        <a href='udalosti.jsp'>seznam udalosti</a>
    </body>
</html>
